diff -Naur openssl-1.0.0q.orig/crypto/ocsp/ocsp_ext.c openssl-1.0.0q/crypto/ocsp/ocsp_ext.c
--- openssl-1.0.0q.orig/crypto/ocsp/ocsp_ext.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/ocsp/ocsp_ext.c	2017-04-25 16:23:40.543621044 +0200
@@ -61,8 +61,13 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include <cryptlib.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+
+#ifndef OPENSSL_NO_OCSP
+
 #include <openssl/objects.h>
 #include <openssl/x509.h>
 #include <openssl/ocsp.h>
@@ -73,16 +78,19 @@
 
 /* OCSP request extensions */
 
+#ifndef OPERA_SMALL_VERSION
 int OCSP_REQUEST_get_ext_count(OCSP_REQUEST *x)
 	{
 	return(X509v3_get_ext_count(x->tbsRequest->requestExtensions));
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 int OCSP_REQUEST_get_ext_by_NID(OCSP_REQUEST *x, int nid, int lastpos)
 	{
 	return(X509v3_get_ext_by_NID(x->tbsRequest->requestExtensions,nid,lastpos));
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int OCSP_REQUEST_get_ext_by_OBJ(OCSP_REQUEST *x, ASN1_OBJECT *obj, int lastpos)
 	{
 	return(X509v3_get_ext_by_OBJ(x->tbsRequest->requestExtensions,obj,lastpos));
@@ -92,12 +100,14 @@
 	{
 	return(X509v3_get_ext_by_critical(x->tbsRequest->requestExtensions,crit,lastpos));
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 X509_EXTENSION *OCSP_REQUEST_get_ext(OCSP_REQUEST *x, int loc)
 	{
 	return(X509v3_get_ext(x->tbsRequest->requestExtensions,loc));
 	}
 
+#ifndef OPERA_SMALL_VERSION
 X509_EXTENSION *OCSP_REQUEST_delete_ext(OCSP_REQUEST *x, int loc)
 	{
 	return(X509v3_delete_ext(x->tbsRequest->requestExtensions,loc));
@@ -173,12 +183,14 @@
 	{
 	return(X509v3_get_ext_count(x->tbsResponseData->responseExtensions));
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 int OCSP_BASICRESP_get_ext_by_NID(OCSP_BASICRESP *x, int nid, int lastpos)
 	{
 	return(X509v3_get_ext_by_NID(x->tbsResponseData->responseExtensions,nid,lastpos));
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int OCSP_BASICRESP_get_ext_by_OBJ(OCSP_BASICRESP *x, ASN1_OBJECT *obj, int lastpos)
 	{
 	return(X509v3_get_ext_by_OBJ(x->tbsResponseData->responseExtensions,obj,lastpos));
@@ -188,12 +200,14 @@
 	{
 	return(X509v3_get_ext_by_critical(x->tbsResponseData->responseExtensions,crit,lastpos));
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 X509_EXTENSION *OCSP_BASICRESP_get_ext(OCSP_BASICRESP *x, int loc)
 	{
 	return(X509v3_get_ext(x->tbsResponseData->responseExtensions,loc));
 	}
 
+#ifndef OPERA_SMALL_VERSION
 X509_EXTENSION *OCSP_BASICRESP_delete_ext(OCSP_BASICRESP *x, int loc)
 	{
 	return(X509v3_delete_ext(x->tbsResponseData->responseExtensions,loc));
@@ -306,6 +320,7 @@
 	return NULL;
 	}
 #endif
+#endif /* OPERA_SMALL_VERSION */
 
 /* Nonce handling functions */
 
@@ -315,6 +330,7 @@
  * nonce, previous versions used the raw nonce.
  */
 
+#ifdef TLS_ADD_OCSP_NONCE
 static int ocsp_add1_nonce(STACK_OF(X509_EXTENSION) **exts, unsigned char *val, int len)
 	{
 	unsigned char *tmpval;
@@ -327,13 +343,13 @@
          * it relies on library internals.
 	 */
 	os.length = ASN1_object_size(0, len, V_ASN1_OCTET_STRING);
-	os.data = OPENSSL_malloc(os.length);
+	os.data = (unsigned char *) OPENSSL_malloc(os.length);
 	if (os.data == NULL)
 		goto err;
 	tmpval = os.data;
 	ASN1_put_object(&tmpval, 0, len, V_ASN1_OCTET_STRING, V_ASN1_UNIVERSAL);
 	if (val)
-		memcpy(tmpval, val, len);
+		op_memcpy(tmpval, val, len);
 	else
 		RAND_pseudo_bytes(tmpval, len);
 	if(!X509V3_add1_i2d(exts, NID_id_pkix_OCSP_Nonce,
@@ -345,21 +361,26 @@
 		OPENSSL_free(os.data);
 	return ret;
 	}
+#endif
 
 
 /* Add nonce to an OCSP request */
 
+#ifdef TLS_ADD_OCSP_NONCE
 int OCSP_request_add1_nonce(OCSP_REQUEST *req, unsigned char *val, int len)
 	{
 	return ocsp_add1_nonce(&req->tbsRequest->requestExtensions, val, len);
 	}
+#endif
 
 /* Same as above but for a response */
 
+#ifndef OPERA_SMALL_VERSION
 int OCSP_basic_add1_nonce(OCSP_BASICRESP *resp, unsigned char *val, int len)
 	{
 	return ocsp_add1_nonce(&resp->tbsResponseData->responseExtensions, val, len);
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 /* Check nonce validity in a request and response.
  * Return value reflects result:
@@ -409,6 +430,7 @@
  * a response.
  */
 
+#ifndef OPERA_SMALL_VERSION
 int OCSP_copy_nonce(OCSP_BASICRESP *resp, OCSP_REQUEST *req)
 	{
 	X509_EXTENSION *req_ext;
@@ -515,4 +537,6 @@
 	if (sloc) OCSP_SERVICELOC_free(sloc);
 	return x;
 	}
+#endif /* OPERA_SMALL_VERSION */
 
+#endif /* OPENSSL_NO_OCSP */
diff -Naur openssl-1.0.0q.orig/crypto/ocsp/ocsp_ht.c openssl-1.0.0q/crypto/ocsp/ocsp_ht.c
--- openssl-1.0.0q.orig/crypto/ocsp/ocsp_ht.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/ocsp/ocsp_ht.c	2017-04-25 16:23:40.544620891 +0200
@@ -56,17 +56,21 @@
  *
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <ctype.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "e_os.h"
 #include <openssl/asn1.h>
 #include <openssl/ocsp.h>
 #include <openssl/err.h>
 #include <openssl/buffer.h>
 #ifdef OPENSSL_SYS_SUNOS
-#define strtoul (unsigned long)strtol
+#define op_strtoul (unsigned long)strtol
 #endif /* OPENSSL_SYS_SUNOS */
 
 /* Stateful OCSP request code, supporting non-blocking I/O */
@@ -197,7 +201,7 @@
 	char *p, *q, *r;
 	/* Skip to first white space (passed protocol info) */
 
-	for(p = line; *p && !isspace((unsigned char)*p); p++)
+	for(p = line; *p && !op_isspace((unsigned char)*p); p++)
 		continue;
 	if(!*p)
 		{
@@ -207,7 +211,7 @@
 		}
 
 	/* Skip past white space to start of response code */
-	while(*p && isspace((unsigned char)*p))
+	while(*p && op_isspace((unsigned char)*p))
 		p++;
 
 	if(!*p)
@@ -218,7 +222,7 @@
 		}
 
 	/* Find end of response code: first whitespace after start of code */
-	for(q = p; *q && !isspace((unsigned char)*q); q++)
+	for(q = p; *q && !op_isspace((unsigned char)*q); q++)
 		continue;
 
 	if(!*q)
@@ -232,13 +236,13 @@
 	*q++ = 0;
 
 	/* Attempt to parse numeric code */
-	retcode = strtoul(p, &r, 10);
+	retcode = op_strtoul(p, &r, 10);
 
 	if(*r)
 		return 0;
 
 	/* Skip over any leading white space in message */
-	while(*q && isspace((unsigned char)*q))
+	while(*q && op_isspace((unsigned char)*q))
 		q++;
 
 	if(*q)
@@ -247,7 +251,7 @@
 		 * CRLF) */
 
 		/* We know q has a non white space character so this is OK */
-		for(r = q + strlen(q) - 1; isspace((unsigned char)*r); r--)
+		for(r = q + op_strlen(q) - 1; op_isspace((unsigned char)*r); r--)
 			*r = 0;
 		}
 	if(retcode != 200)
@@ -343,7 +347,7 @@
 		 * calling BIO_gets or we'll just get a partial read.
 		 */
 		n = BIO_get_mem_data(rctx->mem, &p);
-		if ((n <= 0) || !memchr(p, '\n', n))
+		if ((n <= 0) || !op_memchr(p, '\n', n))
 			{
 			if (n >= rctx->iobuflen)
 				{
diff -Naur openssl-1.0.0q.orig/crypto/ocsp/ocsp_lib.c openssl-1.0.0q/crypto/ocsp/ocsp_lib.c
--- openssl-1.0.0q.orig/crypto/ocsp/ocsp_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ocsp/ocsp_lib.c	2017-04-25 16:23:40.545621857 +0200
@@ -61,8 +61,13 @@
  *
  */
 
+#ifndef OPENSSL_NO_OCSP
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include <cryptlib.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/objects.h>
 #include <openssl/rand.h>
 #include <openssl/x509.h>
@@ -70,6 +75,8 @@
 #include <openssl/x509v3.h>
 #include <openssl/ocsp.h>
 #include <openssl/asn1t.h>
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 /* Convert a certificate and its issuer to an OCSP_CERTID */
 
@@ -105,7 +112,7 @@
         unsigned int i;
 	X509_ALGOR *alg;
 	OCSP_CERTID *cid = NULL;
-	unsigned char md[EVP_MAX_MD_SIZE];
+	unsigned char md[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-05-25 yngve */
 
 	if (!(cid = OCSP_CERTID_new())) goto err;
 
@@ -164,6 +171,7 @@
  * it is SSL.
  */
 
+#ifndef OPERA_SMALL_VERSION
 int OCSP_parse_url(char *url, char **phost, char **pport, char **ppath, int *pssl)
 	{
 	char *p, *buf;
@@ -179,18 +187,18 @@
 	if (!buf) goto mem_err;
 
 	/* Check for initial colon */
-	p = strchr(buf, ':');
+	p = op_strchr(buf, ':');
 
 	if (!p) goto parse_err;
 
 	*(p++) = '\0';
 
-	if (!strcmp(buf, "http"))
+	if (!op_strcmp(buf, "http"))
 		{
 		*pssl = 0;
 		port = "80";
 		}
-	else if (!strcmp(buf, "https"))
+	else if (!op_strcmp(buf, "https"))
 		{
 		*pssl = 1;
 		port = "443";
@@ -208,7 +216,7 @@
 
 	/* Check for trailing part of path */
 
-	p = strchr(p, '/');
+	p = op_strchr(p, '/');
 
 	if (!p) 
 		*ppath = BUF_strdup("/");
@@ -233,7 +241,7 @@
 		}
 
 	/* Look for optional ':' for port number */
-	if ((p = strchr(p, ':')))
+	if ((p = op_strchr(host, ':')))
 		{
 		*p = 0;
 		port = p + 1;
@@ -272,5 +280,8 @@
 	return 0;
 
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 IMPLEMENT_ASN1_DUP_FUNCTION(OCSP_CERTID)
+
+#endif /* OPENSSL_NO_OCSP */
diff -Naur openssl-1.0.0q.orig/crypto/ocsp/ocsp_srv.c openssl-1.0.0q/crypto/ocsp/ocsp_srv.c
--- openssl-1.0.0q.orig/crypto/ocsp/ocsp_srv.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/ocsp/ocsp_srv.c	2017-04-25 16:23:40.546620307 +0200
@@ -56,7 +56,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <cryptlib.h>
 #include <openssl/objects.h>
 #include <openssl/rand.h>
diff -Naur openssl-1.0.0q.orig/crypto/ocsp/ocsp_vfy.c openssl-1.0.0q/crypto/ocsp/ocsp_vfy.c
--- openssl-1.0.0q.orig/crypto/ocsp/ocsp_vfy.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ocsp/ocsp_vfy.c	2017-04-25 16:23:40.547620435 +0200
@@ -56,9 +56,16 @@
  *
  */
 
+#include <openssl/cryptlib.h>
+
+#ifndef OPENSSL_NO_OCSP
+
 #include <openssl/ocsp.h>
 #include <openssl/err.h>
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include "modules/libopeay/libopeay_arrays.h"
 
 static int ocsp_find_signer(X509 **psigner, OCSP_BASICRESP *bs, STACK_OF(X509) *certs,
 				X509_STORE *st, unsigned long flags);
@@ -67,8 +74,11 @@
 static int ocsp_check_ids(STACK_OF(OCSP_SINGLERESP) *sresp, OCSP_CERTID **ret);
 static int ocsp_match_issuerid(X509 *cert, OCSP_CERTID *cid, STACK_OF(OCSP_SINGLERESP) *sresp);
 static int ocsp_check_delegated(X509 *x, int flags);
+
+#ifndef OPERA_SMALL_VERSION
 static int ocsp_req_find_signer(X509 **psigner, OCSP_REQUEST *req, X509_NAME *nm, STACK_OF(X509) *certs,
 				X509_STORE *st, unsigned long flags);
+#endif
 
 /* Verify a basic response message */
 
@@ -124,8 +134,13 @@
 			{
 			i = X509_STORE_CTX_get_error(&ctx);	
 			OCSPerr(OCSP_F_OCSP_BASIC_VERIFY,OCSP_R_CERTIFICATE_VERIFY_ERROR);
+#ifdef OPERA_SMALL_VERSION
+			// Suppress warning "variable set but not used".
+			(void) i;
+#else
 			ERR_add_error_data(2, "Verify error:",
 					X509_verify_cert_error_string(i));
+#endif
                         goto end;
                 	}
 		if(flags & OCSP_NOCHECKS)
@@ -206,7 +221,7 @@
 		{
 		x = sk_X509_value(certs, i);
 		X509_pubkey_digest(x, EVP_sha1(), tmphash, NULL);
-		if(!memcmp(keyhash, tmphash, SHA_DIGEST_LENGTH))
+		if(!op_memcmp(keyhash, tmphash, SHA_DIGEST_LENGTH))
 			return x;
 		}
 	return NULL;
@@ -304,7 +319,7 @@
 		const EVP_MD *dgst;
 		X509_NAME *iname;
 		int mdlen;
-		unsigned char md[EVP_MAX_MD_SIZE];
+		unsigned char md[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-05-25 yngve */
 		if (!(dgst = EVP_get_digestbyobj(cid->hashAlgorithm->algorithm)))
 			{
 			OCSPerr(OCSP_F_OCSP_MATCH_ISSUERID, OCSP_R_UNKNOWN_MESSAGE_DIGEST);
@@ -320,7 +335,7 @@
 		iname = X509_get_subject_name(cert);
 		if (!X509_NAME_digest(iname, dgst, md, NULL))
 			return -1;
-		if (memcmp(md, cid->issuerNameHash->data, mdlen))
+		if (op_memcmp(md, cid->issuerNameHash->data, mdlen))
 			return 0;
 		X509_pubkey_digest(cert, dgst, md, NULL);
 		if (memcmp(md, cid->issuerKeyHash->data, mdlen))
@@ -360,6 +375,7 @@
  * against a given trust value.
  */
 
+#ifndef OPERA_SMALL_VERSION
 int OCSP_request_verify(OCSP_REQUEST *req, STACK_OF(X509) *certs, X509_STORE *store, unsigned long flags)
         {
 	X509 *signer;
@@ -421,8 +437,10 @@
 			{
 			ret = X509_STORE_CTX_get_error(&ctx);	
 			OCSPerr(OCSP_F_OCSP_REQUEST_VERIFY,OCSP_R_CERTIFICATE_VERIFY_ERROR);
+#ifndef OPERA_SMALL_VERSION
 			ERR_add_error_data(2, "Verify error:",
 					X509_verify_cert_error_string(ret));
+#endif
                         return 0;
                 	}
 		}
@@ -448,3 +466,6 @@
 		}
 	return 0;
 	}
+
+#endif /* OPERA_SMALL_VERSION */
+#endif /* OPENSSL_NO_OCSP */
diff -Naur openssl-1.0.0q.orig/crypto/opensslconf.h openssl-1.0.0q/crypto/opensslconf.h
--- openssl-1.0.0q.orig/crypto/opensslconf.h	2015-01-15 15:56:28.000000000 +0100
+++ openssl-1.0.0q/crypto/opensslconf.h	2017-04-25 16:23:40.551620384 +0200
@@ -111,7 +111,7 @@
 #endif
 #endif
 
-#if (defined(HEADER_NEW_DES_H) || defined(HEADER_DES_H)) && !defined(DES_LONG)
+#if (defined(OPERA_SMALL_VERSION) || defined(HEADER_NEW_DES_H) || defined(HEADER_DES_H)) && !defined(DES_LONG)
 /* If this is set to 'unsigned int' on a DEC Alpha, this gives about a
  * %20 speed up (longs are 8 bytes, int's are 4). */
 #ifndef DES_LONG
@@ -126,9 +126,15 @@
 /* Should we define BN_DIV2W here? */
 
 /* Only one for the following should be defined */
+#if defined(THIRTY_TWO_BIT) && defined(SIXTY_FOUR_BIT)
+#error "You should not define both SIXTY_FOUR_BIT and THIRTY_TWO_BIT"
+#endif
+
+#if !defined(THIRTY_TWO_BIT) && !defined(SIXTY_FOUR_BIT)
+#error "You should really set either SIXTY_FOUR_BIT or THIRTY_TWO_BIT"
+#endif
+
 #undef SIXTY_FOUR_BIT_LONG
-#undef SIXTY_FOUR_BIT
-#define THIRTY_TWO_BIT
 #endif
 
 #if defined(HEADER_RC4_LOCL_H) && !defined(CONFIG_HEADER_RC4_LOCL_H)
diff -Naur openssl-1.0.0q.orig/crypto/opera_mem_clr.cpp openssl-1.0.0q/crypto/opera_mem_clr.cpp
--- openssl-1.0.0q.orig/crypto/opera_mem_clr.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/opera_mem_clr.cpp	2017-04-25 16:23:40.553620359 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "mem_clr.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/ossl_typ.h openssl-1.0.0q/crypto/ossl_typ.h
--- openssl-1.0.0q.orig/crypto/ossl_typ.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ossl_typ.h	2017-04-25 16:23:40.554620207 +0200
@@ -167,7 +167,12 @@
 typedef struct st_ERR_FNS ERR_FNS;
 
 typedef struct engine_st ENGINE;
+
+// Opera also contains a class with name "SSL".
+#ifndef _SSL_USE_OPENSSL_
 typedef struct ssl_st SSL;
+#endif
+
 typedef struct ssl_ctx_st SSL_CTX;
 
 typedef struct X509_POLICY_NODE_st X509_POLICY_NODE;
diff -Naur openssl-1.0.0q.orig/crypto/pem/.gitignore openssl-1.0.0q/crypto/pem/.gitignore
--- openssl-1.0.0q.orig/crypto/pem/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/.gitignore	2017-04-25 16:23:40.555620613 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/pem/pem.h openssl-1.0.0q/crypto/pem/pem.h
--- openssl-1.0.0q.orig/crypto/pem/pem.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/pem.h	2017-04-25 16:23:40.558620157 +0200
@@ -159,7 +159,7 @@
 
 	int cipher;
 	int key_enc;
-	/*	char iv[8]; unused and wrong size */
+	/*	char iv[8]; unused and wrong size  // ARRAY OK 2007-11-07 yngve */
 	} PEM_USER;
 
 typedef struct pem_ctx_st
@@ -176,7 +176,7 @@
 	struct	{
 		int cipher;
 	/* unused, and wrong size
-	   unsigned char iv[8]; */
+	   unsigned char iv[8];  // ARRAY OK 2007-11-07 yngve */
 		} DEK_info;
 		
 	PEM_USER *originator;
@@ -196,7 +196,7 @@
 	int key_len;		/* key length */
 	unsigned char *key;	/* key */
 	/* unused, and wrong size
-	   unsigned char iv[8]; */
+	   unsigned char iv[8];  // ARRAY OK 2007-11-07 yngve */
 
 	
 	int  data_enc;		/* is the data encrypted */
@@ -258,7 +258,7 @@
 #define IMPLEMENT_PEM_read_bio(name, type, str, asn1) \
 type *PEM_read_bio_##name(BIO *bp, type **x, pem_password_cb *cb, void *u)\
 { \
-return PEM_ASN1_read_bio((d2i_of_void *)d2i_##asn1, str,bp,(void **)x,cb,u); \
+return (type *)PEM_ASN1_read_bio((d2i_of_void *)d2i_##asn1, str,bp,(void **)x,cb,u); \
 }
 
 #define IMPLEMENT_PEM_write_bio(name, type, str, asn1) \
@@ -325,6 +325,7 @@
 
 #define DECLARE_PEM_read_fp(name, type) /**/
 #define DECLARE_PEM_write_fp(name, type) /**/
+#define DECLARE_PEM_write_fp_const(name, type) /**/
 #define DECLARE_PEM_write_cb_fp(name, type) /**/
 
 #else
@@ -425,6 +426,7 @@
 		unsigned char *kstr, int klen, pem_password_cb *cd, void *u);
 #endif
 
+#ifndef OPENSSL_NO_FP_API
 int	PEM_read(FILE *fp, char **name, char **header,
 		unsigned char **data,long *len);
 int	PEM_write(FILE *fp,char *name,char *hdr,unsigned char *data,long len);
@@ -435,6 +437,7 @@
 		       int klen,pem_password_cb *callback, void *u);
 STACK_OF(X509_INFO) *	PEM_X509_INFO_read(FILE *fp, STACK_OF(X509_INFO) *sk,
 	pem_password_cb *cb, void *u);
+#endif // !OPENSSL_NO_FP_API
 
 int	PEM_SealInit(PEM_ENCODE_SEAL_CTX *ctx, EVP_CIPHER *type,
 		EVP_MD *md_type, unsigned char **ek, int *ekl,
@@ -523,6 +526,7 @@
 				  pem_password_cb *cb, void *u);
 EVP_PKEY *d2i_PKCS8PrivateKey_bio(BIO *bp, EVP_PKEY **x, pem_password_cb *cb, void *u);
 
+#ifndef OPENSSL_NO_FP_API
 int i2d_PKCS8PrivateKey_fp(FILE *fp, EVP_PKEY *x, const EVP_CIPHER *enc,
 				  char *kstr, int klen,
 				  pem_password_cb *cb, void *u);
@@ -537,6 +541,7 @@
 
 int PEM_write_PKCS8PrivateKey(FILE *fp,EVP_PKEY *x,const EVP_CIPHER *enc,
 			      char *kstr,int klen, pem_password_cb *cd, void *u);
+#endif
 
 EVP_PKEY *PEM_read_bio_Parameters(BIO *bp, EVP_PKEY **x);
 int PEM_write_bio_Parameters(BIO *bp, EVP_PKEY *x);
diff -Naur openssl-1.0.0q.orig/crypto/pem/pem_all.c openssl-1.0.0q/crypto/pem/pem_all.c
--- openssl-1.0.0q.orig/crypto/pem/pem_all.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/pem_all.c	2017-04-25 16:23:40.559620004 +0200
@@ -109,8 +109,10 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bio.h>
 #include <openssl/evp.h>
 #include <openssl/x509.h>
@@ -126,6 +128,8 @@
 #include <openssl/dh.h>
 #endif
 
+#ifndef OPERA_SMALL_VERSION
+
 #ifndef OPENSSL_NO_RSA
 static RSA *pkey_get_rsa(EVP_PKEY *key, RSA **rsa);
 #endif
@@ -141,8 +145,12 @@
 
 IMPLEMENT_PEM_write(X509_REQ_NEW, X509_REQ, PEM_STRING_X509_REQ_OLD, X509_REQ)
 
+#endif // !OPERA_SMALL_VERSION
+
 IMPLEMENT_PEM_rw(X509_CRL, X509_CRL, PEM_STRING_X509_CRL, X509_CRL)
 
+#ifndef OPERA_SMALL_VERSION
+
 IMPLEMENT_PEM_rw(PKCS7, PKCS7, PEM_STRING_PKCS7, PKCS7)
 
 IMPLEMENT_PEM_rw(NETSCAPE_CERT_SEQUENCE, NETSCAPE_CERT_SEQUENCE,
@@ -294,3 +302,5 @@
 #endif
 
 IMPLEMENT_PEM_rw(PUBKEY, EVP_PKEY, PEM_STRING_PUBLIC, PUBKEY)
+
+#endif // !OPERA_SMALL_VERSION
diff -Naur openssl-1.0.0q.orig/crypto/pem/pem_err.c openssl-1.0.0q/crypto/pem/pem_err.c
--- openssl-1.0.0q.orig/crypto/pem/pem_err.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/pem_err.c	2017-04-25 16:23:40.560620970 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/pem.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/pem/pem_info.c openssl-1.0.0q/crypto/pem/pem_info.c
--- openssl-1.0.0q.orig/crypto/pem/pem_info.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/pem/pem_info.c	2017-04-25 16:23:40.561620538 +0200
@@ -56,7 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/buffer.h>
 #include <openssl/objects.h>
@@ -129,8 +134,8 @@
 			goto err;
 			}
 start:
-		if (	(strcmp(name,PEM_STRING_X509) == 0) ||
-			(strcmp(name,PEM_STRING_X509_OLD) == 0))
+		if (	(op_strcmp(name,PEM_STRING_X509) == 0) ||
+			(op_strcmp(name,PEM_STRING_X509_OLD) == 0))
 			{
 			d2i=(D2I_OF(void))d2i_X509;
 			if (xi->x509 != NULL)
@@ -141,7 +146,7 @@
 				}
 			pp=&(xi->x509);
 			}
-		else if ((strcmp(name,PEM_STRING_X509_TRUSTED) == 0))
+		else if ((op_strcmp(name,PEM_STRING_X509_TRUSTED) == 0))
 			{
 			d2i=(D2I_OF(void))d2i_X509_AUX;
 			if (xi->x509 != NULL)
@@ -152,7 +157,7 @@
 				}
 			pp=&(xi->x509);
 			}
-		else if (strcmp(name,PEM_STRING_X509_CRL) == 0)
+		else if (op_strcmp(name,PEM_STRING_X509_CRL) == 0)
 			{
 			d2i=(D2I_OF(void))d2i_X509_CRL;
 			if (xi->crl != NULL)
@@ -165,7 +170,7 @@
 			}
 		else
 #ifndef OPENSSL_NO_RSA
-			if (strcmp(name,PEM_STRING_RSA) == 0)
+			if (op_strcmp(name,PEM_STRING_RSA) == 0)
 			{
 			d2i=(D2I_OF(void))d2i_RSAPrivateKey;
 			if (xi->x_pkey != NULL) 
@@ -187,7 +192,7 @@
 		else
 #endif
 #ifndef OPENSSL_NO_DSA
-			if (strcmp(name,PEM_STRING_DSA) == 0)
+			if (op_strcmp(name,PEM_STRING_DSA) == 0)
 			{
 			d2i=(D2I_OF(void))d2i_DSAPrivateKey;
 			if (xi->x_pkey != NULL) 
@@ -365,7 +370,7 @@
 				}
 
 			/* create the right magic header stuff */
-			OPENSSL_assert(strlen(objstr)+23+2*enc->iv_len+13 <= sizeof buf);
+			OPENSSL_assert(op_strlen(objstr)+23+2*enc->iv_len+13 <= sizeof buf);
 			buf[0]='\0';
 			PEM_proc_type(buf,PEM_TYPE_ENCRYPTED);
 			PEM_dek_info(buf,objstr,enc->iv_len,(char *)iv);
